﻿//////////////////////////////////////////////
// TestRunParameters.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkDebug
{
	class TestObserver ;

	struct TestNameFilters ;
}

/// Includes ---------------------------------

// nkDebug
#include "../Dll/DllDefines.h"

// nkLog
#include <NilkinsLog/Data/StringView.h>

/// Class ------------------------------------

namespace nkDebug
{
	class DLL_NKDEBUG_EXPORT TestRunParameters final
	{
		private :

			// Attributes
			TestNameFilters* _filters ;
			TestObserver* _observer ;

		public  :

			// Functions
			// Constructor, destructor
			TestRunParameters () noexcept ;
			TestRunParameters (const TestRunParameters& other) noexcept ;
			TestRunParameters (TestRunParameters&& other) noexcept ;
			~TestRunParameters () ;

			// Getters
			nkLog::StringView getClassNameFilter () const ;
			nkLog::StringView getFunctionNameFilter () const ;
			TestObserver* getObserver () const ;

			// Setters
			void setClassNameFilter (const nkLog::StringView& value) ;
			void setFunctionNameFilter (const nkLog::StringView& value) ;
			void setObserver (TestObserver* value)  ;

			// Operators
			TestRunParameters& operator= (const TestRunParameters& other) ;
			TestRunParameters& operator= (TestRunParameters&& other) ;
	} ;
}