﻿//////////////////////////////////////////////
// String.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkLog
#include "../Dll/DllDefines.h"

// Standards
#include <string>
#include <string_view>

/// Class ------------------------------------

namespace nkLog
{
	class DLL_LOG_EXPORT String final
	{
		public :

			// Attributes
			char* _data ;
			unsigned long long _size ;

		public :

			// Functions
			// Constructor, destructor
			String () = delete ;
			String (const char* data) ;
			String (const char* data, unsigned long long size) ;
			String (const String& other) ;
			String (String&& other) ;
			~String () ;

			// Operators
			String& operator= (const String& other) ;
			String& operator= (String&& other) ;

		public :

			// Inlined constructors
			template <typename T = std::string>
			String (const std::string& str)
			:	_data (nullptr),
				_size ((unsigned long long)str.size())
			{
				// Copy data over
				_data = new char [_size + 1] ;
				memcpy(_data, str.data(), _size) ;
				_data[_size] = '\0' ;
			}

			template <typename T = std::string_view>
			String (const std::string_view& str)
			:	_data (nullptr),
				_size ((unsigned long long)str.size())
			{
				// Copy data over
				_data = new char [_size + 1] ;
				memcpy(_data, str.data(), _size) ;
				_data[_size] = '\0' ;
			}

		public :

			// Inlined conversions
			template <typename T = std::string>
			operator std::string () const
			{
				return std::string(_data, _size) ;
			}

			template <typename T = std::string_view>
			operator std::string_view () const
			{
				return std::string_view(_data, _size) ;
			}
	} ;
}