﻿//////////////////////////////////////////////
// StringView.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkLog
#include "../Dll/DllDefines.h"

// Standards
#include <string>
#include <string_view>

/// Class ------------------------------------

namespace nkLog
{
	class DLL_LOG_EXPORT StringView final
	{
		public :

			// Attributes
			const char* _data ;
			unsigned long long _size ;

		public :

			// Functions
			// Constructor, destructor
			StringView () = delete ;
			StringView (const char* data) ;
			StringView (const char* data, unsigned long long size) ;
			~StringView () ;

		public :

			// Inlined constructors
			template <typename T = std::string>
			StringView (const std::string& str)
			:	_data (str.data()),
				_size ((unsigned long long)str.size())
			{
				// Nothing to do
			}

			template <typename T = std::string_view>
			StringView (const std::string_view& str)
			:	_data (str.data()),
				_size ((unsigned long long)str.size())
			{
				// Nothing to do
			}

		public :

			// Inlined conversions
			template <typename T = std::string>
			operator std::string () const
			{
				return std::string(_data, _size) ;
			}

			template <typename T = std::string_view>
			operator std::string_view () const
			{
				return std::string_view(_data, _size) ;
			}
	} ;
}