﻿//////////////////////////////////////////////
// Static.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	struct ClickEventData ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

#include "../Enums/Alignment.h"

#include "Component.h"

// Standards
#include <functional>
	
/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Static : public Component
	{
		protected :
		
			// Attributs
			// Callbacks
			std::function<void (Static*, const ClickEventData&)> _clickCallback ;

			// For styling
			ALIGNMENT _alignHorizontal ;
			ALIGNMENT _alignVertical ;
		
		public :
		
			// Constructeur, destructeur
			Static () ;
			~Static () ;

			// Getters
			const std::function<void (Static*, const ClickEventData&)>& getClickCallback () const ;
			ALIGNMENT getAlignHorizontal () const ;
			ALIGNMENT getAlignVertical () const ;

			// Setters
			void setClickCallback (const std::function<void (Static*, const ClickEventData&)>& value) ;
			virtual void setAlignHorizontal (ALIGNMENT value) ;
			virtual void setAlignVertical (ALIGNMENT value) ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}